<template>
    <ul class="nav list-status nav-tabs d-flex justify-content-between">
        <li class="nav-item">
            <a class="nav-link" v-on:click="getOrder(10)" :class="{'active' : tab == 10}" href="#">Tất cả</a>
        </li>
        <li class="nav-item">
            <a class="nav-link" v-on:click="getOrder(0)" :class="{'active' : tab == 0}" href="#">Chờ thanh toán</a>
        </li>
        <li class="nav-item">
            <a class="nav-link" v-on:click="getOrder(1)" :class="{'active' : tab == 1}" href="#">Vận chuyển</a>
        </li>
        <li class="nav-item">
            <a class="nav-link" v-on:click="getOrder(3)" :class="{'active' : tab == 3}" href="#">Hoàn thành</a>
        </li>
        <li class="nav-item">
            <a class="nav-link" v-on:click="getOrder(4)" :class="{'active' : tab == 4}" href="#">Đã hủy</a>
        </li>
        <li class="nav-item">
            <a class="nav-link" v-on:click="getOrder(5)" :class="{'active' : tab == 5}" href="#">Trả hàng/hoàn tiền</a>
        </li>
    </ul>
    <template v-for="(order,index) in orders" :key="index">
        <div v-if="order.order_products.length > 0" class="order">
            <div class="card checkout-address p-4 mt-3">
                <div class="d-flex title justify-content-between align-items-center fs-4 pb-3">
                    <span class="color-black">Đơn hàng: {{ order.code }}</span>
                    <span class="color-status">{{ order.status_des }}</span>
                </div>
                <hr>
                <div class="checkout-product">
                    <template v-for="(product,i) in order.order_products" :key="i">
                        <div class="d-flex">
                            <div class="p-3 pe-0">
                                <img :src="product.thumbnail" width="100" height="100" alt="">
                        </div>
                        <div class="w-100">
                            <div class="p-2 pb-0 d-flex justify-content-between w-100">
                                <div class="product-name">
                                    <span class="fs-4 fw-600 color-black">
                                        {{ product.product_name }}
                                    </span>
                                </div>
                            </div>
                            <div class="d-flex justify-content-between px-2">
                                <div class="fs-5">Số lượng: {{ product.quantity }}</div>
                                    <div class="product-price d-flex align-items-center">
                                        <div class="fs-5 sale p-1" >{{ new Intl.NumberFormat().format(product.price ) }}đ</div>
                                        <div class="price fs-4">{{ new Intl.NumberFormat().format(product.pay_price) }}đ</div>
                                    </div>
                                </div>
                                <button v-if="order.status == 3 && product.reviewed == 0" type="button" v-on:click="setProduct(product)" data-bs-toggle="modal" data-bs-target="#exampleModal" class="mx-2 btn btn-primary">Đánh giá</button>
                            </div>
                        </div>
                    </template>
                </div>
                <hr>
                <div class="d-flex justify-content-between">
                    <span>Ngày đặt hàng: {{ order.create_date }}</span>
                    <div>
                        <div class="product-price text-end">
                            <span class="fs-4">Tổng tiền: <span class="price"> {{ new Intl.NumberFormat().format((order.total_pay)) }}đ</span></span>
                        </div>
                        <div class="product-price text-end">
                            <button v-if="[0,1,7].includes(order.status)" type="button" v-on:click="cancelOrder(order)" class="btn btn-danger" data-toggle="modal" data-target="#exampleModalCenter">Huỷ đơn</button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </template>
    <template v-if="orders.length == 0">
        <div class="order d-flex align-items-center justify-content-center" style="height: 500px;">
            <div>
                <img src="/assets/img/order.png" alt width="200" height="200">
                <p class="text-center">Không có đơn hàng nào</p>
            </div>
        </div>
     </template>
     <div class="modal fade" id="exampleModalCenter" data-backdrop="static" tabindex="-1" role="dialog" aria-labelledby="exampleModalCenterTitle" aria-hidden="true">
        <div class="modal-dialog modal-dialog-centered" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title text-danger fs-3" id="exampleModalLongTitle">Hủy đơn hàng</h5>
                    <button type="button" class="btn" ref="closeModal" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <p v-if="!success" class="text-center">Bạn có chắc chắn muốn hủy đơn hàng {{ orderCancel?.code }} không?</p>
                    <p v-else class="text-success">Bạn đã hủy thành công đơn hàng {{ orderCancel?.code }}?</p>
                </div>
                <div class="modal-footer">
                    <button v-on:click="cancel()" type="button" class="btn btn-primary mx-1">Hủy</button>
                </div>
            </div>
        </div>
    </div>
    <!-- Modal review -->
<div class="modal fade" id="exampleModal" tabindex="-1" aria-labelledby="exampleModalLabel" aria-hidden="true">
    <div class="modal-dialog modal-dialog-centered">
        <div class="modal-content">
            <div class="modal-header">
                <h3 class="modal-title" id="exampleModalLabel">Đánh giá sản phẩm</h3>
                <button ref="Close" type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
            </div>
            <div class="modal-body">
                <form autocomplete="off" @submit.prevent="postReview" method="post" class="needs-validation" novalidate>
                    <div class="modal-center-review">
                        <div class="image-product-review">
                            <img :src="product?.thumbnail" :alt="product?.name">
                        </div>
                        <div class="rate">
                            <input v-model="review.star" type="radio" id="star5" name="rate" :value=5 />
                            <label for="star5" title="text">5 stars</label>
                            <input v-model="review.star" type="radio" id="star4" name="rate" :value=4 />
                            <label for="star4" title="text">4 stars</label>
                            <input v-model="review.star" type="radio" id="star3" name="rate" :value=3 />
                            <label for="star3" title="text">3 stars</label>
                            <input v-model="review.star" type="radio" id="star2" name="rate" :value=2 />
                            <label for="star2" title="text">2 stars</label>
                            <input v-model="review.star" type="radio" id="star1" name="rate" :value=1 />
                            <label for="star1" title="text">1 star</label>
                        </div>
                    </div>
                    <div class="w-100">
                        <textarea 
                            required 
                            :class="{'is-invalid': errors?.comment}" 
                            v-model="review.comment" 
                            class="form-control" rows="3" 
                            placeholder="Hãy chia sẻ cám nhận của bạn về sản phẩm...">
                        </textarea>
                        <div v-if="errors?.comment" class="invalid-feedback">{{ errors?.comment[0] }}</div>
                    </div>
                    <div class="info-review pt-3">
                        <div class="d-flex">
                            <div class="w-100">
                                <input 
                                :class="{'is-invalid': errors?.name}"
                                v-model="review.name" required
                                type="text" class="form-control me-1" 
                                placeholder="Nhập họ và tên">
                                <div v-if="errors?.name" class="invalid-feedback">{{ errors?.name[0] }}</div>
                            </div>
                            <div class="w-100">
                                <input 
                                    :class="{'is-invalid': errors?.phone}"
                                    v-model="review.phone" required
                                    type="text" class="form-control ms-1" 
                                    placeholder="Nhập số điện thoại">
                                <div v-if="errors?.phone" class="invalid-feedback">{{ errors?.phone[0] }}</div>
                            </div>
                        </div>
                        <div class="w-100">
                            <input 
                                :class="{'is-invalid': errors?.email}"
                                v-model="review.email" required
                                type="email" class="form-control mt-2" 
                                placeholder="Nhập email để nhận thông báo phản hồi">
                            <div v-if="errors?.email" class="invalid-feedback">{{ errors?.email[0] }}</div>
                        </div>
                    </div>
                </form>
            </div>
            <div class="modal-footer d-flex justify-content-center">
                <button v-on:click="postReview()" type="button" class="btn btn-primary">Gửi đánh giá</button>
            </div>
        </div>
    </div>
</div>
</template>

<script>
    export default {
        name: 'list-order',
        data(){
            return {
                tab: 10,
                orders: [],
                orderCancel: null,
                success: false,
                review: {
                    product_id: 0,
                    order_id: 0,
                    type: 1,
                    status: 0,
                    name: '',
                    email: '',
                    phone: '',
                    comment: '',
                    star: 5,
                    order_product: 0
                },
                errors: {},
                product: {}
            }
        },
        methods:{
            getOrder(status = 10){
                this.tab = status;
                this.orders = [];
                this.$store.dispatch('listOrder', status).then(res => {
                    this.orders = res.data;
                })
            },
            postReview(){
                this.$store.dispatch('review', this.review).then(res => {
                    if(res.status === 200) {
                        this.$refs.Close.click();
                        this.$refs.openSuccesReview.click();
                        this.getOrder(this.tab);
                    }
                }).catch(error => {
                    this.errors = error.response.data.errors;
                })
            },
            cancelOrder(order) {
                this.orderCancel = order
            },
            setProduct(order){
                this.product = order;
                this.review.product_id = order.product_id;
                this.review.order_id = order.order_id;
                this.review.order_product = order.id
            },
            cancel() {
                this.$store.dispatch('cancelOrder', this.orderCancel.id).then(res => {
                    if(res.status === 200) {
                        this.success = true;
                        setTimeout(() => {
                            this.success = false;
                            this.$refs.closeModal.click();
                        }, 1500);
                        this.orderCancel = null;
                        this.getOrder(4);
                    }
                })
            }
        },
        mounted() {
            this.getOrder(10);
        }
    }
</script>
<style lang="scss">
.status-des {
    color: #cb1c22;
    font-weight: 600;
}
.rate {
    float: left;
    height: 46px;
    padding: 0 10px;
}
.rate:not(:checked) > input {
    position:absolute;
    top:-9999px;
}
.rate:not(:checked) > label {
    float:right;
    width:1em;
    overflow:hidden;
    white-space:nowrap;
    cursor:pointer;
    font-size:30px;
    color:#ccc;
}
.rate:not(:checked) > label:before {
    content: '★ ';
}
.rate > input:checked ~ label {
    color: #cb1c22;    
}
.rate:not(:checked) > label:hover,
.rate:not(:checked) > label:hover ~ label {
    color: #cb1c22;  
}
.rate > input:checked + label:hover,
.rate > input:checked + label:hover ~ label,
.rate > input:checked ~ label:hover,
.rate > input:checked ~ label:hover ~ label,
.rate > label:hover ~ input:checked ~ label {
    color: #cb1c22;
}
.image-product-review img{
    width: 100px;
    height: 100px;
}
.modal-center-review {
    display: flex;
    flex-direction: column;
    align-items: center;
}
</style>